<?php

function replace_uri($out)
{

 $pattern = '#(^|[^\"=]{1})(http://|ftp://|mailto:)([^\s<>]+)([\s\n<>]|$)#sm';

 $emailsearch[]="/([\s])([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
 $emailsearch[]="/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
 $emailreplace[]="\\1<a href=\"mailto:\\2\">\\2</a>";
 $emailreplace[]="<a href=\"mailto:\\0\">\\0</a>";
 $out = preg_replace($pattern,"\\1<a target=\"_blank\" href=\"\\2\\3\">\\3</a>\\4",$out);

 if (strpos($out, "@")) $out = preg_replace($emailsearch, $emailreplace, $out);
 return $out;

};

function bb_codes($text)
	{
	#$text = preg_replace("/\[IMG\](.*?)\[\/IMG\]/si", "<img src=\"\\1\" border=\"0\">", $text);

   $text = preg_replace("/\[b\](.*?)\[\/b\]/si", "<b>\\1</b>", $text);
   $text = preg_replace("/\[i\](.*?)\[\/i\]/si", "<i>\\1</i>", $text);
   $text = preg_replace("/\[u\](.*?)\[\/u\]/si", "<u>\\1</u>", $text);


   $text = preg_replace("/\[CENTER\](.*?)\[\/CENTER\]/si", "<div align=\"center\">\\1</div>", $text);
	$text = preg_replace("/\[ALIGN\=CENTER\](.*?)\[\/ALIGN\]/si", "<div align=\"center\">\\1</div>", $text);

   $text = preg_replace("/\[SIZE=(8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27)\](.*?)\[\/SIZE\]/si", "<span style=\"font-size:\\1px\">\\2</span>", $text);

   while(eregi("\[COLOR=(.*)\](.*)\[\/COLOR\]",$text)) $text = preg_replace("/\[COLOR=(.*?)\](.*?)\[\/COLOR\]/si", "<font color=\"\\1\">\\2</font>", $text);

   $text = preg_replace("/\[list\](.*?)\[\/list\]/si", "<ul>\\1</ul>", $text);

   $text = preg_replace("/\[\*\]/si", "<li>", $text);




	//Aus http://link.de wird [URL]http://link.de[/URL]

	$text = preg_replace("/\[EMAIL\](.*?)\[\/EMAIL\]/si", "<a href=\"mailto:\\1\">\\1</a>", $text);
	$text = preg_replace("/\[EMAIL=(.*?)\](.*?)\[\/EMAIL\]/si", "<a href=\"mailto:\\1\">\\2</a>", $text);

	$urlsuch[]="/([^]_a-z0-9-=\"'\/])((https?|ftp):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si";
	$urlsuch[]="/^((https?|ftp):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si";


	$urlreplace[]="\\1[URL]\\2\\4[/URL]";
	$urlreplace[]="[URL]\\1\\3[/URL]";
	$emailsuch[]="/([\s])([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
	$emailsuch[]="/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
	$emailreplace[]="\\1[EMAIL]\\2[/EMAIL]";
	$emailreplace[]="[EMAIL]\\0[/EMAIL]";
	$text = preg_replace($urlsuch, $urlreplace, $text);
	if (strpos($text, "@")) $text = preg_replace($emailsuch, $emailreplace, $text);



	//E-Mail Adressen und Links werden anklickbar
	$text = preg_replace("/\[URL\]www.(.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"http://www.\\1\">www.\\1</a>", $text);

	$text = preg_replace("/\[URL\](.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"\\1\">\\1</a>", $text);


	$text = preg_replace("/\[URL=www.(.*?)\](.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"http://www.\\1\">\\2</a>", $text);

	$text = preg_replace("/\[URL=(.*?)\](.*?)\[\/URL\]/si", "<a target=\"_blank\" href=\"\\1\">\\2</a>", $text);


	$text = preg_replace("/\[EMAIL\](.*?)\[\/EMAIL\]/si", "<a href=\"mailto:\\1\">\\1</a>", $text);
	$text = preg_replace("/\[EMAIL=(.*?)\](.*?)\[\/EMAIL\]/si", "<a href=\"mailto:\\1\">\\2</a>", $text);



	return $text;

	}
?>